`timescale 1ns / 1ps
//////////////////////////////////////////////////////////////////////////////////
// Company: 
// Engineer: 
// 
// Create Date:    14:38:29 04/14/2016 
// Design Name: 
// Module Name:    freq_div 
// Project Name: 
// Target Devices: 
// Tool versions: 
// Description: 
//
// Dependencies: 
//
// Revision: 
// Revision 0.01 - File Created
// Additional Comments: 
//
//////////////////////////////////////////////////////////////////////////////////
module freq_div(
   clk_out, // divided clock output
	clk_ctl, // divided clock output for scan freq
	clk, // global clock input
	rst_n, // active low reset
	clk_debounce
	);
	
	output clk_out; // divided output
	output [1:0] clk_ctl; // divided output for scan freq
	output clk_debounce;
	
	input clk; // global clock input
	input rst_n; // active low reset
	
	reg clk_out; // clk output (in always block)
	reg [1:0] clk_ctl; // clk output (in always block)
	reg [14:0] cnt_l;// temp buf of the counter
	reg [5:0] cnt_h;// temp buf of the counter
	reg [24:0] cnt_tmp; // input to dff (in always block)
	reg clk_debounce;
	
	// Combinational logics: increment, neglecting overflow 
	always @*
	cnt_tmp = {clk_out,cnt_h,clk_debounce,clk_ctl,cnt_l} + 1'b1;
	
	// Sequential logics: Flip flops
	always @(posedge clk or negedge rst_n)
	if (~rst_n) {clk_out, cnt_h, clk_debounce, clk_ctl, cnt_l}<=24'd0;
	else {clk_out,cnt_h, clk_debounce, clk_ctl, cnt_l}<=cnt_tmp;


endmodule
