`timescale 1ns / 1ps
//////////////////////////////////////////////////////////////////////////////////
// Company: 
// Engineer: 
// 
// Create Date:    15:01:35 04/14/2016 
// Design Name: 
// Module Name:    hourscounter 
// Project Name: 
// Target Devices: 
// Tool versions: 
// Description: 
//
// Dependencies: 
//
// Revision: 
// Revision 0.01 - File Created
// Additional Comments: 
//
//////////////////////////////////////////////////////////////////////////////////
`define ENABLED 1 // ENABLE indicator
`define DISABLED 0 // EIDABLE indicator
module hourscounter(
   hour1, // digit 1 for second
	hour0, // digit 0 for second
	clk, // global clock
	rst_n //active low reset
	);

	// outputs
	output [3:0] hour1; // digit 1 for second
	output [3:0] hour0; // digit 0 for second
	// inputs
	input clk; // global clock signal
	input rst_n; // low active reset

	// temporatory nets
	reg load_def_hour; // enabled to load second value
	wire cout_hour0, cout_hour1; // BCD counter carryout

	// return from 24 to 00
	always @(hour0 or hour1)
	  if ((hour1==4'd2)&&(hour0==4'd3))
		 load_def_hour = `ENABLED;
	  else
		 load_def_hour = `DISABLED;

	// counter for digit 0
	upcounter Udig0(
	  .value(hour0),  // digit 0 of second
	  .carry(cout_hour0),  // carry out for digit 0
	  .clk(clk),  // clock
	  .rst_n(rst_n),  // asynchronous low active reset
	  .increase(`ENABLED),  // always increasing
	  .load_default(load_def_hour),  // enable load default value
	  .def_value(4'd0) // default value for counter
	);

	// counter for digit 1
	upcounter Udig1(
	  .value(hour1),  // digit 1 of second
	  .carry(cout_hour1),  // carry out for digit 1
	  .clk(clk),  // clock
	  .rst_n(rst_n),  // asynchronous low active reset
	  .increase(cout_hour0),  // increasing when digit 0 carry out
	  .load_default(load_def_hour),  // enable load default value
	  .def_value(4'd0) // default value for counter
	);


endmodule
