`timescale 1ns / 1ps
//////////////////////////////////////////////////////////////////////////////////
// Company: 
// Engineer: 
// 
// Create Date:    15:11:36 04/14/2016 
// Design Name: 
// Module Name:    mode 
// Project Name: 
// Target Devices: 
// Tool versions: 
// Description: 
//
// Dependencies: 
//
// Revision: 
// Revision 0.01 - File Created
// Additional Comments: 
//
//////////////////////////////////////////////////////////////////////////////////
`define STAT_24MODE 1'b0
`define STAT_AMPM 1'b1
`define MODE_24MODE 1'b0
`define MODE_AMPM 1'b1
module mode(
   hour1,
	hour0,
	clk,
	rst_n,
	modesel,
	showout0,
	showout1,
	showout2,
	showout3
	);
	 
	input [3:0] hour1, hour0;
	input clk, rst_n;
	input modesel;
	output [3:0] showout3, showout2, showout1, showout0;

	reg state, next_state;
	reg mode;
	reg [3:0] showout3, showout2, showout1, showout0;
	reg [3:0] AMPM1, AMPM0, T1, T0;
	reg [3:0] trans1, trans0;
	//FSM
	always@*
		case(state)
			`STAT_24MODE:
			if(modesel)
			begin
				next_state=`STAT_AMPM;
				mode=`MODE_AMPM;
			end
			else
			begin
				next_state=`STAT_24MODE;
				mode=`MODE_24MODE;
			end
			`STAT_AMPM:
			if(modesel)
			begin
				next_state=`STAT_24MODE;
				mode=`MODE_24MODE;
			end
			else
			begin
				next_state=`STAT_AMPM;
				mode=`MODE_AMPM;
			end
			default:
			begin
				next_state=`STAT_24MODE;
				mode=`MODE_24MODE;	
			end
		endcase
	//transition
	always@(posedge clk or negedge rst_n)
	if(~rst_n)
	 state<=`STAT_24MODE;
	else
	 state<=next_state;
	//transform 24 to AM/PM
	always@*
		if({hour1,hour0}>{8'b0001_0010})
		begin
			AMPM1<=4'd11; 
			AMPM0<=4'd12;
			if({hour1,hour0}=={4'd2,4'd0}||{hour1,hour0}=={4'd2,4'd1})
			begin
				trans1=hour1-4'd2;
				trans0=hour0+4'd8;
			end
			else
			begin
				trans1=hour1-4'd1;
				trans0=hour0-4'd2;
			end
			T1<=trans1; 
			T0<=trans0;
			
		end
		
		else if({hour1,hour0}=={8'b0001_0010})
		begin
			AMPM1<=4'd11; 
			AMPM0<=4'd12;
			T1<=hour1; 
			T0<=hour0;
		end
		
		else if({hour1,hour0}<{8'b0001_0010} && {hour1,hour0}>{8'b0000_0000})
		begin
			AMPM1<=4'd10; 
			AMPM0<=4'd12; 
			T1<=hour1; 
			T0<=hour0;
		end
		
		else 
		begin  //{hour1,hour0}=={8'b0000_0000}
			AMPM1<=4'd10; 
			AMPM0<=4'd12; 
			T1<=4'd1; 
			T0<=4'd2;
		end
	//decide display
	always@*
		case(mode)
		`MODE_24MODE:
			begin
			showout3<=4'd2;
			showout2<=4'd4;
			showout1<=hour1;		
			showout0<=hour0;
			end
		`MODE_AMPM:
			begin
				showout3<=AMPM1;
				showout2<=AMPM0;
				showout1<=T1;		
				showout0<=T0;
			end
		default:
			begin
			showout3<=4'd2;
			showout2<=4'd4;
			showout1<=hour1;		
			showout0<=hour0;
			end
		endcase


endmodule
